import sys
import os

def setup_path():
    
    currdir = os.path.dirname(__file__)  # Get the current directory
    sys.path.append(os.path.join(currdir, 'src'))  # Add the 'src' directory to the Python path
    xSAP_code_dir = None
    xSAP_dir = os.path.join(currdir, '..', 'xSAP')  # Set the path to the 'xSAP' directory
    
    if os.path.exists(xSAP_dir):  # Check if 'xSAP' directory exists
        xSAP_build_dir = os.path.join(xSAP_dir, 'build')  # Set the path to the 'build' directory within 'xSAP'
        if os.path.exists(xSAP_build_dir):  # Check if 'build' directory exists within 'xSAP'
            xSAP_code_dir = os.path.join(xSAP_build_dir, 'code')  # Set the path to the 'code' directory within 'build'
        else:
            xSAP_code_dir = os.path.join(xSAP_dir, 'code')  # Set the path to the 'code' directory within 'xSAP'
    else:
        xSAP_code_dir = os.path.join(currdir, 'src', 'xSAP', 'code')  # Set the path to the 'code' directory within 'src'
    
    if xSAP_code_dir is None:  # Check if 'xSAP' code directory was not found
        raise Exception("Couldn't find xSAP directory")
    else:
        sys.path.append(xSAP_code_dir)  # Add the 'xSAP' code directory to the Python path

    pass
