class TreeNode():
    """
    node
    """

    def __init__(self, info=None, children=[], parent_win=None,
                 size=1, size_p=1, depth=0):
        self.parent = parent_win
        self.children = children
        self.info = info
        self.size = size  # all
        self.size_p = size_p  # paging
        self.depth = depth
        return


class Event():
    """
    even node
    """

    def __init__(self, val):

        self.name = val[0]
        self.description = val[1]
        if val[3] and val[2] == "Fixed":
            self.failure_model_parameter = "P = " + val[3]
        else:
            self.failure_model_parameter = "P = " + "0.0"
        return

    def isGate(self):
        return False


class Gate():
    """
    gate node
    """

    def __init__(self, val=[]):

        self.name = val[0]
        self.type = val[1]
        self.description = val[2] if val[2] is not None and val[2] != "" else val[0]
        self.children = []
        t1 = val[3:-2]
        for i in t1:
            if i != "":
                t2 = i.split(':')
                self.children.append((t2[0], t2[1]))

        self.page = val[-2]

        if val[-1]:
            prefix = "NuSMV-SA probability: "
            if val[-1].startswith(prefix):
                self.notes = "P = " + val[-1][len(prefix):]
            else:
                self.notes = "P = " + val[-1]
        else:
            self.notes = val[-1]

        return

    def isGate(self):
        return True
