
# %HEADER


class NonWellFormedXmlError(Exception):
    """An object indicating that a certain fault injection document is not a
    well-formed XML document.
    """

    def __init__(self, error_description):
        """Initializes the NonWellFormedXmlError object.

        @param   error_description: The description of the syntax error.
        @type    error_description: string
        """
        self.description = error_description

    def __str__(self):
        """Returns a string representation of this syntax error.

        @return: The description of this syntax error.
        @rtype:  string
        """
        return self.description


class DocumentSyntaxError(Exception):
    """An object representing a syntax error in a fault injection document.

    Syntax errors are detected by validating the document against an XML
    Schema Definition.
    """

    def __init__(self, error_description):
        """Initializes the DocumentSyntaxError object.

        @param   error_description: The description of the syntax error.
        @type    error_description: string
        """
        self.description = error_description

    def __str__(self):
        """Returns a string representation of this syntax error.

        @return: The description of this syntax error.
        @rtype:  string
        """
        return self.description
