
import os


# ----------------------------------------------------------------------
# Logging
# ----------------------------------------------------------------------
LOGGING_SYS_LEVEL = "debug"
LOGGING_TEST_LEVEL = ""
LOGGING_USER_LEVEL = ""
LOGGING_XSAP_LEVEL = "info"
LOGGING_XSAP_CONSOLE_LEVEL = "info"
LOGGING_FNAME = "xsap.log"


# ----------------------------------------------------------------------
# Directories
# ----------------------------------------------------------------------

# code dir or code egg file
_this = os.path.dirname(__file__)
_code = os.path.abspath(os.path.join(_this, "../.."))

# TOP_LEVEL_DIR top level directory, the root for all sources

if os.path.isfile(_code):
    # egg file, gets rid of it in paths
    TOP_LEVEL_DIR = os.path.abspath(os.path.join(
        os.path.dirname(_code), ".."))
    BUILD_DIR = TOP_LEVEL_DIR
else:
    TOP_LEVEL_DIR = os.path.abspath(os.path.join(_code, ".."))
    BUILD_DIR = os.path.abspath(os.path.join(TOP_LEVEL_DIR, "build"))

CODE_DIR = _code

data_dir = os.path.join(BUILD_DIR, "data")
if not os.path.exists(data_dir):
    data_dir = os.path.abspath(os.path.join(TOP_LEVEL_DIR, "data"))
DATA_DIR = data_dir
SCHEMA_DIR = os.path.join(DATA_DIR, "schema")

# place for binary external executable files
bin_dir = os.path.join(BUILD_DIR, "bin")
if not os.path.exists(bin_dir):
    bin_dir = os.path.join(TOP_LEVEL_DIR, "bin")
BIN_DIR = bin_dir

# print ">"*20 + "TOP_LEVEL_DIR", TOP_LEVEL_DIR
# print ">"*20 + "CODE_DIR", CODE_DIR
# print ">"*20 + "BUILD_DIR", BUILD_DIR
# print ">"*20 + "DATA_DIR", DATA_DIR
# print ">"*20 + "SCHEMA_DIR", SCHEMA_DIR
# print ">"*20 + "BIN_DIR", BIN_DIR

# ----------------------------------------------------------------------
# Tools
# ----------------------------------------------------------------------
XSAP = "xSAP"
DEGRADED_MODE = "NuSMV"
NUSMV = "NuSMV"
NUXMV = "nuXmv"

# ----------------------------------------------------------------------
# Tools generic
# ----------------------------------------------------------------------
BMC_USE_SBMC     = True
SBMC_IS_COMPLETE = False
BMC_LENGTH       = 10       # length (k) of BMC
KLIVE_BOUND      = 10       # bound for k-liveness search

SHOW_PROPERTIES_FILE_NAME = "show_property.xml"


# ----------------------------------------------------------------------
# xSAP Specific
# ----------------------------------------------------------------------
XSAP_COMPACT_FMEA_TABLE = False

# ----------------------------------------------------------------------
# Engines
# ----------------------------------------------------------------------

FT_ENGINES = "bmc bdd msat_bmc sbmc ic3 bmc_bdd sbmc_bdd".split()
(FT_ENGINE_BMC,
 FT_ENGINE_BDD,
 FT_ENGINE_MSAT_BMC,
 FT_ENGINE_SBMC,
 FT_ENGINE_PARAM,
 FT_ENGINE_BMC_INC_BDD,
 FT_ENGINE_SBMC_INC_BDD, ) = FT_ENGINES

FMEA_ENGINES = "bdd bmc msat".split()
(FMEA_ENGINE_BDD,
 FMEA_ENGINE_BMC,
 FMEA_ENGINE_MSAT) = FMEA_ENGINES

MC_ENGINES = "bdd bmc msat_bmc ic3".split()
(MC_ENGINE_BDD,
 MC_ENGINE_BMC,
 MC_ENGINE_MSAT_BMC,
 MC_ENGINE_IC3, ) = MC_ENGINES
