'''
Created on Oct 10, 2011

@author: rayan
'''

from feic.fe.data_structure.model.xmlBound import XmlBoundLineno
from lxml import etree


class Event (XmlBoundLineno):
    """Manages the creation of the structure event. Can generate a new
    structure based on its value or read from an existing one. Also
    handles the dumping to FE.

    """
    NAME = "name"
    TYPE = "type"
    CONN = "connected"
    EVNT = "event"
    BINDS = "binds"

    def __init__(self, **kwargs):
        XmlBoundLineno.__init__(self, {self.TYPE: "type",
                                       self.NAME: "name",
                                       self.CONN: "connected",
                                       self.BINDS: "binds"},
                                self.EVNT, **kwargs)
        return

    def toXML(self):
        """Creates a lxml element based on the values contained in the
        current instance of the element. Assigns parameters and
        processes subelements.

        """
        root = etree.Element(self.tag)
        self.connected = "no" if self.binds == "" else "yes"

        self._toXMLAttr(root, iter(self.m_map.values()))
        if XmlBoundLineno.dumping_fe:
            if self.connected == "no":
                self.deleteAttrs(root, ["binds"])

            self.deleteAttrs(root, ["desc"])

        return root

    pass  # end of class
