
# %HEADER

# INTERFACES


from collections import OrderedDict


def generate_tle_dic(tfpg_assoc_struct):
    """Given the internal represention of an associations file, it builds
    the TLE dictionary, which basically consists of the list of
    discrepancies names (monitored and unmonitored) prefixed by 'tfpgsynth_'.

    @param tfpg_assoc_struct: the internal represention of the associations
    @type  tfpg_assoc_struct: TfpgAssociations
    """

    tle_dic = OrderedDict()

    for md in tfpg_assoc_struct.get_var_names_of_monitored_discr():
        tle_dic[md] = "tfpgsynth_%s" % md
    for ud in tfpg_assoc_struct.get_var_names_of_unmonitored_discr():
        tle_dic[ud] = "tfpgsynth_%s" % ud

    return tle_dic
