
from fractions import Fraction
from mathsat import *

def is_float(string):
    assert isinstance(string, str)
    try:
        float(string)
    except ValueError:
        return False
    return True

def is_fraction(string):
    assert isinstance(string, str)
    try:
        Fraction(string)
    except ValueError:
        return False
    return True

def fraction_string_to_float(string):
    if not is_fraction(string):
        return None
    return float(Fraction(string))

def init_msat_env(menv, vmt_string):
    mic3 = msat_create_ic3(menv)
    res = msat_ic3_from_smtlib2(mic3, vmt_string)
    assert res == 0
    msat_destroy_ic3(mic3)
    return

